Subject: bug#74031: [PATCH] srfi-64: Accept complex numbers in test-approximate.

From: lloda <[email-masked]>
Date: Sat, 26 Oct 2024 20:46:25 +0200

> On 26 Oct 2024, at 19:22, Ludovic Courtès <[email-masked]> wrote:
> 
> Hi,
> 
> (Cc: lloda.)
> 
> Tomas Volf <[email-masked]> skribis:
> 
>> The specification mandates reals, but the reference implementation
>> supports complex numbers.  So as implementation extension, support them
>> as well.
>> 
>> * module/srfi/srfi-64.scm (within-epsilon): Support complex arguments.
>> ---
>> Proposal for how to extend test-approximate to handle complex arguments.
>> However it differs from the original one.  That one expected `error' to be a
>> real number, and used it for comparing both real parts and imaginary parts.
>> 
>> To me, that seems weird.  I would consider it useful to be able to have
>> different errors for real and imaginary parts.
>> 
>> However I cannot remember the last time I have used complex numbers, so I am not
>> sure I am qualified to have an opinion here.  What do other people think?
> 
> Not sure either.  Daniel, is that what you would expect?
> 
> Perhaps we should check the reference implementation?
> 
> Ludo’.

Sorry, I didn't notice this. I replied on another message, but to be clear, the expected error should always be a real number, no matter what you're comparing. If one wants to have separate errors for real and imaginary parts, then one can simply use test-approximate on the real and imaginary parts separately.

Regards 

  Daniel